/**
 * Licensed under the Common Development and Distribution License,
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.sun.com/cddl/
 *   
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or 
 * implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

package com.sun.facelets.compiler;

import java.io.IOException;

import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

final class UILiteralText extends UILeaf {
    
    private final String text;
    
    public UILiteralText(String text) {
        this.text = text;
    }

    public void encodeBegin(FacesContext faces) throws IOException {
        ResponseWriter writer = faces.getResponseWriter();
        writer.write(this.text);
    }
    public String toString() {
        return this.text;
    }

}
