/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.config;

import javax.faces.application.*;

public class SetupUtil {


  static String[] standardComponents = {
    "javax.faces.Column", "javax.faces.component.UIColumn",
    "javax.faces.Command", "javax.faces.component.UICommand",
    "javax.faces.Data", "javax.faces.component.UIData",
    "javax.faces.Graphic", "javax.faces.component.UIGraphic",
    "javax.faces.Input", "javax.faces.component.UIInput",
    "javax.faces.Message", "javax.faces.component.UIMessage",
    "javax.faces.Messages", "javax.faces.component.UIMessages",
    "javax.faces.NamingContainer", "javax.faces.component.UINamingContainer",
    "javax.faces.Output", "javax.faces.component.UIOutput",
    "javax.faces.Panel", "javax.faces.component.UIPanel",

    "javax.faces.Parameter", "javax.faces.component.UIParameter",
    
    "javax.faces.SelectBoolean", "javax.faces.component.UISelectBoolean",
    "javax.faces.SelectItem", "javax.faces.component.UISelectItem",
    "javax.faces.SelectItems", "javax.faces.component.UISelectItems",
    "javax.faces.SelectMany", "javax.faces.component.UISelectMany",
    "javax.faces.SelectOne", "javax.faces.component.UISelectOne",
    "javax.faces.ViewRoot", "javax.faces.component.UIViewRoot",
    "javax.faces.HtmlCommandButton", "javax.faces.component.html.HtmlCommandButton",
    "javax.faces.HtmlCommandLink", "javax.faces.component.html.HtmlCommandLink",
    "javax.faces.HtmlDataTable", "javax.faces.component.html.HtmlDataTable",
    "javax.faces.HtmlForm", "javax.faces.component.html.HtmlForm",
    "javax.faces.HtmlGraphicImage", "javax.faces.component.html.HtmlGraphicImage",
    "javax.faces.HtmlInputHidden", "javax.faces.component.html.HtmlInputHidden",
    "javax.faces.HtmlInputSecret", "javax.faces.component.html.HtmlInputSecret",
    "javax.faces.HtmlInputText", "javax.faces.component.html.HtmlInputText",
    "javax.faces.HtmlInputTextarea", "javax.faces.component.html.HtmlInputTextarea",
    "javax.faces.HtmlMessage", "javax.faces.component.html.HtmlMessage",
    "javax.faces.HtmlMessages", "javax.faces.component.html.HtmlMessages",
    "javax.faces.HtmlOutputFormat", "javax.faces.component.html.HtmlOutputFormat",
    "javax.faces.HtmlOutputLabel", "javax.faces.component.html.HtmlOutputLabel",
    "javax.faces.HtmlOutputLink", "javax.faces.component.html.HtmlOutputLink",
    "javax.faces.HtmlOutputText", "javax.faces.component.html.HtmlOutputText",
    "javax.faces.HtmlPanelGrid", "javax.faces.component.html.HtmlPanelGrid",
    "javax.faces.HtmlPanelGroup", "javax.faces.component.html.HtmlPanelGroup",
    "javax.faces.HtmlSelectBooleanCheckbox", "javax.faces.component.html.HtmlSelectBooleanCheckbox",
    "javax.faces.HtmlSelectManyCheckbox", "javax.faces.component.html.HtmlSelectManyCheckbox",
    "javax.faces.HtmlSelectManyListbox", "javax.faces.component.html.HtmlSelectManyListbox",
    "javax.faces.HtmlSelectManyMenu", "javax.faces.component.html.HtmlSelectManyMenu",
    "javax.faces.HtmlSelectOneListbox", "javax.faces.component.html.HtmlSelectOneListbox",
    "javax.faces.HtmlSelectOneMenu", "javax.faces.component.html.HtmlSelectOneMenu",
    "javax.faces.HtmlSelectOneRadio", "javax.faces.component.html.HtmlSelectOneRadio",
  };

  // Q dwarf.jsf.context.DwarfRenderKitFactory

  static String[] dwarfComponents = {
    "javax.faces.Command", "javax.faces.component.UICommand",
  };
  
  public void addStandardComponents(Application application) {
    addComponents(application, standardComponents);
  }
  
  public void addComponents(Application application, String[] components) {

    for (int i = 0; i < components.length; i += 2) {

      String componentType = components[i + 0];
      String componentClass = components[i + 1];

      application.addComponent(componentType, componentClass);
    }
  }
}
