/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.renderkit;

import com.sun.faces.renderkit.RenderKitImpl;
import java.io.OutputStream;
import java.io.Writer;
import javax.faces.context.ResponseStream;
import javax.faces.context.ResponseWriter;
import javax.faces.render.RenderKit;
import javax.faces.render.Renderer;
import javax.faces.render.ResponseStateManager;
import strawberry.renderkit.html_basic.JpResponseWriter;

/**
 * Created on 2007/06/09, 22:36
 */
public class RenderKitEx extends RenderKit {
    
    RenderKit renderKit = null;
    /** Creates a new instance of RenderKitEx */
    public RenderKitEx() {
        renderKit = new RenderKitImpl();
    }

    public void addRenderer(String s1, String s2, Renderer renderer) {
        renderKit.addRenderer(s1, s2, renderer);
    }

    public ResponseStream createResponseStream(OutputStream os) {
        return renderKit.createResponseStream(os);
    }

    public ResponseWriter createResponseWriter(Writer writer, String contentType, String encoding) {

      return new JpResponseWriter( writer,  contentType,  encoding);
    
    }

    public ResponseStateManager getResponseStateManager() {
        return renderKit.getResponseStateManager();
    }

    public Renderer getRenderer(String s1, String s2) {
        return renderKit.getRenderer(s1, s2);
    }
    
}
