package strawberry.renderkit.html_basic;

import com.sun.faces.renderkit.RenderKitImpl;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.Map;
import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import java.util.logging.*;
/**
 * @author masa
 */
public class DebugRendererRenderer extends HtmlBasicRenderer {

  // jdk1.4 logging
  protected final static Logger log = Logger.getLogger("strawberry.ren");
  /** Creates a new instance of DebugRenderer */
  public DebugRendererRenderer() {
  }

  public void encodeEnd(FacesContext context, UIComponent component) throws IOException {

    String renderKitId = (String) component.getAttributes().get("renderKitId");

    log.info("renderKitId = " + renderKitId);

    
    ResponseWriter writer = context.getResponseWriter();

    Application app = context.getApplication();

    UIViewRoot root = new UIViewRoot();
    if (renderKitId != null) {
      root.setRenderKitId(renderKitId);
    } else {
      root.setRenderKitId("HTML_BASIC");
    }
    context.setViewRoot(root);
    RenderKitImpl rk = (RenderKitImpl) context.getRenderKit();
    Map familys = rk.getRendererFamilies();
    Iterator it4 = familys.keySet().iterator();
    while (it4.hasNext()) {
      Object key = it4.next();
      writer.startElement("h1", null);
      writer.writeText("getRendererFamilies:", "getRendererFamilies:");
      String sKey = key.toString();
      writer.writeText(sKey, sKey);
      writer.endElement("h1");
      Map rens = (Map) familys.get(key);
      Iterator it5 = rens.keySet().iterator();
      printIt(writer, it5);
    }
  }

  public void printIt(ResponseWriter writer, Iterator it) throws IOException {

    ArrayList list = new ArrayList();
    while (it.hasNext()) {
      Object obj = it.next();
      list.add(obj);
    }

    Collections.sort(list);

    for (int i = 0; i < list.size(); i++) {
      Object wk = list.get(i);
      String str = wk.toString();
      
      writer.startElement("p", null);
      writer.writeText(str, str);
      writer.endElement("p");
    }
  }

}
