/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.wapper;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.security.Principal;
import java.util.*;
import javax.faces.context.ExternalContext;
import java.util.logging.*;
/**
 * Created on 2006/11/22
 */
public class ExternalContextProxy  extends ExternalContext{
  
  // jdk1.4 logging
  protected final static Logger log = Logger.getLogger("strawberry.ExternalContextProxy");


  ExternalContext externalContext;
  
  /** RXgN^ */
  public ExternalContextProxy() {
  }

  public Object getSession(boolean b) {
    log.info("************************* getSession");
    return externalContext.getSession(b);
  }

  public void log(String string, Throwable throwable) {
    log.info("************************* log");
  }

  public void redirect(String string) throws IOException {
    log.info("************************* redirect");
    externalContext.redirect(string);
  }

  public void log(String string) {
    log.info("************************* log");
  }

  public boolean isUserInRole(String string) {
    log.info("************************* isUserInRole");
    return externalContext.isUserInRole(string);
  }

  public Set getResourcePaths(String string) {
    log.info("************************* getResourcePaths");
    return externalContext.getResourcePaths(string);
  }

  public String getInitParameter(String string) {
    log.info("************************* getInitParameter");
    return externalContext.getInitParameter(string);
  }

  public String encodeResourceURL(String string) {
    log.info("************************* encodeResourceURL");
    return externalContext.encodeResourceURL(string);
  }

  public String encodeNamespace(String string) {
    log.info("************************* encodeNamespace");
    return externalContext.encodeNamespace(string);
  }

  public String encodeActionURL(String string) {
    log.info("************************* encodeActionURL");
    return externalContext.encodeActionURL(string);
  }

  public void dispatch(String string) throws IOException {
    log.info("************************* dispatch");
    externalContext.dispatch(string);
  }

  public URL getResource(String string) throws MalformedURLException {
    log.info("************************* getResource");
    return externalContext.getResource(string);
  }

  public InputStream getResourceAsStream(String string) {
    log.info("************************* getResourceAsStream");
    return externalContext.getResourceAsStream(string);
  }

  public Principal getUserPrincipal() {
    log.info("************************* getUserPrincipal");
    return externalContext.getUserPrincipal();
  }

  public Map getSessionMap() {
    log.info("************************* getSessionMap");
    return externalContext.getSessionMap();
  }

  public Object getResponse() {
    log.info("************************* getResponse");
    return externalContext.getResponse();
  }

  public Map getRequestCookieMap() {
    log.info("************************* getRequestCookieMap");
    return externalContext.getRequestCookieMap();
  }

  public String getRequestContextPath() {
    log.info("************************* getRequestContextPath");
    return externalContext.getRequestContextPath();
  }

  public Object getRequest() {
    log.info("************************* getRequest");
    return externalContext.getRequest();
  }

  public String getRemoteUser() {
    log.info("************************* getRemoteUser");
    return externalContext.getRemoteUser();
  }

  public Map getInitParameterMap() {
    log.info("************************* getInitParameterMap");
    return externalContext.getInitParameterMap();
  }

  public Object getContext() {
    log.info("************************* getContext");
    return externalContext.getContext();
  }

  public String getAuthType() {
    log.info("************************* getAuthType");
    return externalContext.getAuthType();
  }

  public Map getApplicationMap() {
    log.info("************************* getApplicationMap");
    return externalContext.getApplicationMap();
  }

  public Map getRequestHeaderMap() {
    log.info("************************* getRequestHeaderMap");
    return externalContext.getRequestHeaderMap();
  }

  public Map getRequestHeaderValuesMap() {
    log.info("************************* getRequestHeaderValuesMap");
    return externalContext.getRequestHeaderValuesMap();
  }

  public Locale getRequestLocale() {
    log.info("************************* getRequestLocale");
    return externalContext.getRequestLocale();
  }

  public Iterator getRequestLocales() {
    log.info("************************* getRequestLocales");
    return externalContext.getRequestLocales();
  }

  public Map getRequestMap() {
    log.info("************************* getRequestMap");
    return externalContext.getRequestMap();
  }

  public Map getRequestParameterMap() {
    log.info("************************* getRequestParameterMap");
    return externalContext.getRequestParameterMap();
  }

  public Iterator getRequestParameterNames() {
    log.info("************************* getRequestParameterNames");
    return externalContext.getRequestParameterNames();
  }

  public Map getRequestParameterValuesMap() {
    log.info("************************* getRequestParameterValuesMap");
    return externalContext.getRequestParameterValuesMap();
  }

  public String getRequestPathInfo() {
    log.info("************************* getRequestPathInfo");
    return externalContext.getRequestPathInfo();
  }

  public String getRequestServletPath() {
    log.info("************************* getRequestServletPath");
    return externalContext.getRequestServletPath();
  }
  
}
