/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package fesi.sample;

import FESI.AST.ASTProgram;
import FESI.Interpreter.StringEvaluationSource;
import FESI.Parser.EcmaScript;
import junit.framework.*;
/**
 * Created on 2007/05/14
 */
public class ParserTest extends TestCase {
  
  public ParserTest(String testName) {
    super(testName);
  }
  
  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }
  
  public void test01() {
/*    
    String theSource = "1+2";

Program
 Statement
  BinaryExpressionSequence
   [1]
   <"+">
   [2]
  */  
    /*
    String theSource = "function a(x) { return x + 1; }";
    Program
 FunctionDeclaration
  <a>
  FormalParameterList
   <x>
  StatementList
   Statement
    ReturnStatement
     BinaryExpressionSequence
      <x>
      <"+">
      [1]
*/
    String theSource = " aaa.bbb.ccc; ";
    try {
      
      ASTProgram programNode = null;
      StringEvaluationSource es = new StringEvaluationSource(theSource, null);
      // Hack - this ensures correct parsing of // comments
      // even if no EOL is present (as in an eval('1//a'))
      if (!theSource.endsWith("\n")) {
        theSource += "\n";
      }
      
      java.io.StringReader is =
              new java.io.StringReader(theSource);
      EcmaScript parser = new EcmaScript(is);
      programNode = (ASTProgram)parser.Program();
      System.out.println();
      System.out.println("Dump parse tree of eval (debugParse true)");
      programNode.dump("");
      
      
    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  
}
