/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package fesi.sample;

import FESI.jslib.JSException;
import FESI.jslib.JSGlobalObject;
import FESI.jslib.JSUtil;
import java.io.DataInputStream;
import testmock.fesi.NewClass;
import junit.framework.*;
/**
 * Created on 2007/05/19
 */
public class SimpleInterpTest extends TestCase {
    
    public SimpleInterpTest(String testName) {
        super(testName);
    }
    // The evaluator
    JSGlobalObject global = null;
    
    protected void setUp() throws Exception {    }
    
    protected void tearDown() throws Exception {    }
    
    // TODO add test methods here. The name must begin with 'test'. For example:
    public void testHello() {
        String[] extensions = new String[] {"FESI.Extensions.BasicIO",
        "FESI.Extensions.JavaAccess",
        "FESI.Extensions.FileIO"};
//        String[] extensions = new String[0] ;
        try {
            global = JSUtil.makeEvaluator(extensions);
            
            NewClass nc = new NewClass();
            nc.setName("");
            nc.setNum(123);
            global.setMember("a", nc);
//            global.setMember("a", "value of A");
            
        } catch (JSException e) {
            System.err.println("Cannot initialize FESI");
            System.err.println("Error " + e.getMessage());
            System.exit(1);
        }
        
        
        
        
        // Create the stream to interpret
        DataInputStream ins = new DataInputStream(System.in);
        String input = null;
//        String[] cmds = {"1+2", "a.name", "exit()"};
//        String[] cmds = {"1+2","Math.PI","Math.cos(3.14)", "a.name", "a.name.length" };
        
        String[] cmds = {
            "function f(x){return x+1} ", "f(2)",
            "function g(x){return x-1} ", "g(2)",
            
            "GC = GregorianCalendar = Packages.java.util.GregorianCalendar",
            "new GC()",
            
        };
        
        
        // Main read eval print loop
        for (int i = 0; i < cmds.length; i++) {
            
            /* Read a command
            System.out.print("> "); System.out.flush();
            try {
                input = ins.readLine();
            } catch (IOException e) {
                e.printStackTrace();
                System.err.println(e);
                System.exit(1);
            }*/
            input = cmds[i];
            
            // Exit on empty line or EOF
            if (input == null) break;
            if (input.equals("")) break;
            
            // Evaluate and print if any result
            try {
                Object result = global.eval(input); // Basic evaluation
                // Object result = global.evalAsFunction(input); // Basic evaluation
                if (result!=null) System.out.println(result.toString());
            } catch (JSException e) {
                
                Throwable oe = e.getOriginatingException();
                if (oe != null) {
                    oe.printStackTrace();
                } else {
                    e.printStackTrace();
                }
                System.out.println("** Error evaluating '" + input + "'");
                System.out.println(e.getMessage());
            }
        } // while
        
        System.out.println("SimpleIntrp exiting");
        
    }
    
}
