/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.lifecycle;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import junit.framework.*;
import strawberry.TestResourceConfig;
import strawberry.init.FacesContextInitializer;
import strawberry.init.FacesContextInitializer1;
import strawberry.mockup.MockExternalContextImpl2;
import strawberry.mockup.MockHttpServletRequest;
import testmock.event.*;

/**
 * Created on 2007/04/19    @\ǉꂽCtTCÑeXg
 */
public class LifecycleImplTest extends TestCase {
  
  public LifecycleImplTest(String testName) {
    super(testName);
  }

  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }

  public static Test suite() {
    TestSuite suite = new TestSuite(LifecycleImplTest.class);
    return suite;
  }

  /*   AfterRestoreView  CvgĂ
   *    R|[lg̃\bhĂ΂鎖m߂
   */
  public void testExecute() {
    System.out.println("execute");
    
    UIViewRoot root = new UIViewRoot();
    UIInputForTest uii = new UIInputForTest(); //AfterRestoreView Ă
    root.getChildren().add(uii);

    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    TestResourceConfig rc = new TestResourceConfig("/a");
    FacesContextInitializer sup = new FacesContextInitializer1();
    FacesContext context = sup.createFacesContext(ec, rc);
    context.setViewRoot(root);

    // CtTCNBeXgΏ
    LifecycleImpl instance = new LifecycleImpl();
    instance.addPhaseListener(new strawberry.event.PhaseListenerImpl());
    instance.execute(context);
    
    FacesContext arg = uii.getAfterRestoreViewArg();
    //  UIInputForTest  afterRestoreViewĂ΂Ă鎖m߂
    System.out.println("arg = " + arg);
    assertTrue(context == arg);
  }
  // jdk1.4 logging
  protected final static Logger phaseLog = Logger.getLogger("strawberry.PhaseListener");

  /*   AfterUpdateModelValues  CvgĂ
   *    R|[lg̃\bhĂ΂鎖m߂
   */
  public void _testExecute2() {
    System.out.println("execute2");
    phaseLog.setLevel(Level.FINEST);
    
    UIViewRoot root = new UIViewRoot();
    UIInputForAUMVTest uii = new UIInputForAUMVTest(); //AfterUpdateModelValues Ă
    root.getChildren().add(uii);

    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    MockHttpServletRequest req = (MockHttpServletRequest) ec.getRequest();
    req.setMethod("POST");
    
    TestResourceConfig rc = new TestResourceConfig("/a");
    FacesContextInitializer sup = new FacesContextInitializer1();
    FacesContext context = sup.createFacesContext(ec, rc);
    context.setViewRoot(root);

    // CtTCNBeXgΏ
    LifecycleImpl instance = new LifecycleImpl();
    instance.addPhaseListener(new strawberry.event.PhaseListenerImpl());
    instance.execute(context);
    
    FacesContext arg = uii.getAfterUpdateModelValuesArg();
    //  UIInputForTest  afterRestoreViewĂ΂Ă鎖m߂
    System.out.println("arg = " + arg);
    assertTrue(context == arg);
  }

}
