/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.lifecycle;

import javax.faces.application.Application;
import junit.framework.*;
import strawberry.application.ApplicationImpl;
import strawberry.context.FacesContextEL;
import strawberry.mockup.MockExternalContextImpl2;
import strawberry.mockup.MockHttpServletRequest;
import testmock.viewhandler.ViewHandlerForTest2;
import java.util.logging.*;
import strawberry.mockup.MockServletContext;

/**
 * Created on 2007/06/14
 */
public class LifecycleImpl_viewIdTest extends TestCase {
  
    protected final static Logger log = Logger.getLogger("strawberry.lifecycle");
    
  public LifecycleImpl_viewIdTest(String testName) {
    super(testName);
  }

  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }

  public static Test suite() {
    TestSuite suite = new TestSuite(LifecycleImpl_viewIdTest.class);
    return suite;
  }

  /*   Lifecycle viewId ̌vZWm߂
   */
  public void testViewId() {
    System.out.println("testViewId");
    log.setLevel(Level.FINER);
    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    MockHttpServletRequest req = (MockHttpServletRequest) ec.getRequest();
    req.setServletPath("/servlet");
    req.setPathInfo("/Bar");
    FacesContextEL context = new FacesContextEL(ec);
    Application app = new ApplicationImpl();
    context.setApplication(app);
    // ǂviewIDn邩ׂ郂bN
    ViewHandlerForTest2 vhft = new ViewHandlerForTest2();
    context.getApplication().setViewHandler(vhft);

    // CtTCNBeXgΏ
    // RestoreViewPhase.java viewIDvZ
    LifecycleImpl instance = new LifecycleImpl();
    instance.execute(context);
    
    String viewId = vhft.getViewId();
    System.out.println("viewId = " + viewId);
    // WIȓ鎖m߂
    assertEquals("/Bar", viewId);
  }

  /*   Lifecycle viewId ̌vZJX^}CYꂽm߂
   */
  public void testViewId2() {
    System.out.println("testViewId2");
    log.setLevel(Level.FINER);
    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    MockServletContext sc = (MockServletContext) ec.getContext();
    // ̐ݒ肪ƁAJX^}CYꂽviewIDvZ
    sc.addInitParameter("strawberry.CUSTOMIZED_VIEWID_MODE", "true");
    
    MockHttpServletRequest req = (MockHttpServletRequest) ec.getRequest();
    req.setServletPath("/servlet");
    req.setPathInfo("/Bar");
    FacesContextEL context = new FacesContextEL(ec);
    Application app = new ApplicationImpl();
    context.setApplication(app);
    // ǂviewIDn邩ׂ郂bN
    // RestoreViewPhase.java viewIDvZ
    ViewHandlerForTest2 vhft = new ViewHandlerForTest2();
    context.getApplication().setViewHandler(vhft);

    // CtTCNBeXgΏ
    LifecycleImpl instance = new LifecycleImpl();
    instance.execute(context);
    
    String viewId = vhft.getViewId();
    System.out.println("viewId = " + viewId);
    // WIȓ鎖m߂
    assertEquals("/servlet/Bar", viewId);
  }

}
