/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.mockup;

import junit.framework.*;
import java.io.*;
import java.util.*;
import javax.servlet.http.*;

/**
 * Created on 2007/06/10,
 */
public class MockHttpServletRequestTest extends TestCase {
    
    public MockHttpServletRequestTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {    }
    protected void tearDown() throws Exception {    }

    public static Test suite() {
        TestSuite suite = new TestSuite(MockHttpServletRequestTest.class);
        return suite;
    }

    /**
     * Test of getParameter method, of class strawberry.mockup.MockHttpServletRequest.
     */
    public void testGetParameter() throws Exception {
        System.out.println("getParameter");
        
        MockHttpServletRequest instance = new MockHttpServletRequest();

        String kanji = "";
        String iso = new String(kanji.getBytes("Shift_JIS"), "8859_1");
        System.out.println("bytes =" + iso.length());
        instance.addParameter("aaa", iso);

        String kana = "";
        String iso2 = new String(kana.getBytes("Shift_JIS"), "8859_1");
        System.out.println("bytes =" + iso2.length());
        instance.addParameter("bbb", iso2);
        
        
        HashMap map = new HashMap();
        // mF\bh
        setData(map, instance);
        
        System.out.println("map =" + map);
    }
  public void setData(Map af,  HttpServletRequest req) throws IOException {

    _getParameters(af, req);

//    String uri = req.getRequestURI();
  }

  /**
   *
   */
  private static void _getParameters(Map af, HttpServletRequest req) throws IOException {
    Enumeration e = req.getParameterNames();
    while (e.hasMoreElements()) {
      String key = (String) e.nextElement();
      String[] values = req.getParameterValues(key);
      String userIn = new String(values[0].getBytes("8859_1"), "MS932");
      af.put( key , removeControlCode(userIn));
    }
  }

  private static String removeControlCode(String in) {

    StringBuffer sb = new StringBuffer();
    int n = in.length();
    for (int i = 0; i < n; i++) {
      char c = in.charAt(i);
      if (c == 0x7f) {
      } else if ('\0' <= c && c < ' ') {
      } else {
        sb.append(c);
      }
    }
    return sb.toString();
  }

    
}
