/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.system;

import java.math.BigDecimal;
import java.util.HashMap;
import junit.framework.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import strawberry.mockup.MockHttpServletRequest;
import strawberry.tools.FaceletsBridgeUtil;
import strawberry.tools.TestUtil;
/**
 * Created on 2007/06/08
 */
public class ConverterTest extends TestCase {
  
  public ConverterTest(String testName) {
    super(testName);
  }

  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }

  public static Test suite() {
    TestSuite suite = new TestSuite(ConverterTest.class);
    return suite;
  }
  
  protected final static Logger testLog = Logger.getLogger("strawberry.eXg");
  protected final static Logger updateLog = Logger.getLogger("strawberry.UpdateModelValuesPhase");
  protected final static Logger applyReqLog = Logger.getLogger("strawberry.ApplyRequestValuesPhase");
  protected final static Logger rkRILog = Logger.getLogger("strawberry.rk.RI");
  protected final static Logger renLog = Logger.getLogger("strawberry.ren");

  /**
   *   converter GET
   */
  public void test22() throws Exception {
    testLog.info(" test22 ---------------------");
   
    
//    FaceletsBridgeUtil util = new FaceletsBridgeUtil("test22");
    FaceletsBridgeUtil util = new FaceletsBridgeUtil("ConverterTest", "template/venus");
    util.requestLog.setLevel(Level.FINE);
   renLog.setLevel(Level.FINE);
    
    updateLog.setLevel(Level.FINEST);
    applyReqLog.setLevel(Level.FINEST);
    rkRILog.setLevel(Level.FINEST);

    util.variableLog.setLevel(Level.FINE);

    HashMap map = new HashMap();
    map.put("bd", new BigDecimal("123.45"));
    map.put("date", "2007-6-8");
    util.getSessionMap().put("dataMap", map);
    
//    TestUtil.enableJavaScript();
    // eXgΏۏs
    String html = util.callLifecycle( "/Converter");

    TestUtil.writeFile("/Converter", html);
    
 //   String exp = TestUtil.readFile("/FScript2");
    
 //   assertEquals(exp, html);
    
  }
  /**
   *   converter POST
   */
  public void test22_post() throws Exception {
    testLog.info(" test22_post------------------------------");
    
    FaceletsBridgeUtil util = new FaceletsBridgeUtil("ConverterTest_post", "template/venus");
//    FaceletsBridgeUtil util = new FaceletsBridgeUtil("test22_post");
    util.lifecycleLog.setLevel(Level.FINE);

    HashMap map = new HashMap();
    util.getSessionMap().put("dataMap", map);
    util.setHttpServletRequestMethod("POST");
  
    util.addParameter("it01", "123");
    util.addParameter("it02", "2007/6/8");
    // Ȃ (EC  local  HashMapt̂)
//    util.getRequestParameterMap().put("it01", "123");
//    util.getRequestParameterMap().put("it02", "2007/6/8");
    
    Object debug1=  util.getRequestParameterMap().get("it01");

    testLog.info("debug1 = " + debug1);


//    util.enableJavaScript();
    // eXgΏۏs
    String html = util.callLifecycle( "/Converter");


    testLog.info("map = " + map);
    
    Object obj1 = map.get("date");
    Object obj2 = map.get("bd");

    assertTrue(obj1 != null);
    assertTrue(obj2 != null);
    
    testLog.info("obj1 = " + obj1.getClass().getName());
    testLog.info("obj2 = " + obj2.getClass().getName());

    assertEquals("java.util.Date" , obj1.getClass().getName());
    assertEquals(new Integer(123) , obj2);
    
//    util.writeFile("/Converter_post", html);
    
    String exp = TestUtil.readFile("/Converter_post");
    
   assertEquals(exp, html);
    
  }

}
