/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.viewhandler;

import java.util.logging.*;
import javax.faces.application.ViewHandler;
import javax.faces.component.UIOutput;
import junit.framework.*;
import javax.faces.component.UIViewRoot;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.render.RenderKitFactory;
import strawberry.TestResourceConfig;
import strawberry.init.FacesContextInitializer;
import strawberry.init.FacesContextInitializer1;
import strawberry.mockup.MockExternalContextImpl2;
import strawberry.mockup.MockHttpServletResponse;
/**
 * Created on 2007/05/20, 
 */
public class FaceletViewHandler02Test extends TestCase {
  
  public FaceletViewHandler02Test(String testName) {
    super(testName);
  }
  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }

  public static Test suite() {
    TestSuite suite = new TestSuite(FaceletViewHandler02Test.class);
    return suite;
  }

  protected final static Logger log = Logger.getLogger("strawberry");

  /**
   *   ԂZ[ułPUi񂪕\
   */
  public void testRenderView() throws Exception {
    
    System.out.println("testRenderView");

    log.setLevel(Level.FINE);
//    ExternalContextExMock ec = new ExternalContextExMock();
    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    TestResourceConfig rr = new TestResourceConfig("/a");
    
    FacesContextInitializer fcs = new FacesContextInitializer1();// ύX
    
    fcs.processXmls(ec, rr);
    
    FacesContext context = fcs.createFacesContext(ec, rr);
    
    
    UIViewRoot toRender = new UIViewRoot();
    toRender.setRenderKitId(RenderKitFactory.HTML_BASIC_RENDER_KIT);
    UIOutput uio = new UIOutput();
    toRender.getChildren().add(uio);
    UIOutput uio2 = new UIOutput();
    uio2.setRendererType("stateRenderer");  // NCAgɃZ[uۂɕKvȂ
    toRender.getChildren().add(uio2);
    
    context.setViewRoot(toRender);
    
    context.getExternalContext().getRequestMap().put("facelets.stateManager", "test");
    
    ViewHandler vh = context.getApplication().getViewHandler();    
    // eXgΏۃ\bhĂ
    vh.renderView(context, toRender);

    String str = getResponseAsString(ec);
    System.out.println("str = '" + str + "'");
    
    // PUi݂Ȃ̂ŁAstatesaveĂ鎖m߂
    int idx = str.indexOf("com.sun.faces.VIEW");
    
    assertTrue(idx > 0);
  }
  public String getResponseAsString(ExternalContext ec) {

    MockHttpServletResponse res = (MockHttpServletResponse) ec.getResponse();
    String wk = null;
    try {
      wk = res.getContentAsString();
    } catch (Exception ex) {
      throw new RuntimeException(ex);
    }
    return wk;
  }

}
