/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.viewhandler;

import java.util.logging.*;
import javax.faces.application.ViewHandler;
import javax.faces.component.UIOutput;
import junit.framework.*;
import javax.faces.component.UIViewRoot;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.render.RenderKitFactory;
import strawberry.TestResourceConfig;
import strawberry.init.FacesContextInitializer;
import strawberry.init.FacesContextInitializer1;
import strawberry.mockup.MockExternalContextImpl2;
import strawberry.mockup.MockHttpServletRequest;
import strawberry.mockup.MockHttpServletResponse;
import strawberry.tree.TreePrinter;
/**
 * Created on 2007/05/21, 
 */
public class FaceletViewHandler03Test extends TestCase {
  
  public FaceletViewHandler03Test(String testName) {
    super(testName);
  }
  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }

  public static Test suite() {
    TestSuite suite = new TestSuite(FaceletViewHandler03Test.class);
    return suite;
  }

  protected final static Logger logTest = Logger.getLogger("strawberry.eXg");
  protected final static Logger log = Logger.getLogger("strawberry");

  /**
   *   ԂZ[ułPUi񂪕\
   */
  public void testRenderView() throws Exception {
    
    logTest.info("testRenderView---------------------");

    log.setLevel(Level.FINE);
//    ExternalContextExMock ec = new ExternalContextExMock();
    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    TestResourceConfig rr = new TestResourceConfig("file://localhost/java5/");
    
    FacesContextInitializer fcs = new FacesContextInitializer1();// ύX
    
    fcs.processXmls(ec, rr);
    
    FacesContext context = fcs.createFacesContext(ec, rr);
    
    
    UIViewRoot toRender = new UIViewRoot();
    toRender.setRenderKitId(RenderKitFactory.HTML_BASIC_RENDER_KIT);
    UIOutput uio = new UIOutput();
    toRender.getChildren().add(uio);
    UIOutput uio2 = new UIOutput();
    uio2.setRendererType("stateRenderer");  // NCAgɃZ[uۂɕKvȂ
    toRender.getChildren().add(uio2);
    
    context.setViewRoot(toRender);
    
    context.getExternalContext().getRequestMap().put("facelets.stateManager", "test");
    
    ViewHandler vh = context.getApplication().getViewHandler();    
    // eXgΏۃ\bhĂ
    vh.renderView(context, toRender);

    String str = getResponseAsString(ec);
    logTest.info("str = '" + str + "'");
    
    // PUi݂Ȃ̂ŁAstatesaveĂ鎖m߂
    int idx = str.indexOf("com.sun.faces.VIEW");
    
    assertTrue(idx > 0);

    String wk2 = extractHex(str);
    logTest.info("HEX = '" + wk2 + "'");

    // PUi񂩂AView𕜌
    MockHttpServletRequest req = (MockHttpServletRequest) ec.getRequest();
    req.addParameter("com.sun.faces.VIEW", wk2);
//    ec.getRequestParameterMap().put("com.sun.faces.VIEW", wk2);

    UIViewRoot root = vh.restoreView(context, "/foo");
    logTest.info("root = '" + root + "'");
    // ꂽm߂
    assertTrue(root != null);
    assertTrue(root instanceof UIViewRoot);
    
    /*
    TreeInspector treeInspector = new TreeInspector(context, Level.CONFIG.intValue());
    treeInspector.createPrintWriter();
    treeInspector.print(root);
    treeInspector.closePrintWriter();
    treeInspector.toLogger(logTest, log.getLevel());
    */

    TreePrinter printer = new TreePrinter(logTest, Level.INFO);
    printer.print(root, " ");
  }

  public String getResponseAsString(ExternalContext ec) {

    MockHttpServletResponse res = (MockHttpServletResponse) ec.getResponse();
    String wk = null;
    try {
      wk = res.getContentAsString();
    } catch (Exception ex) {
      throw new RuntimeException(ex);
    }
    return wk;
  }

  /** htmlPUî݂o */
  public String extractHex(String html) {

    int idx = html.indexOf("com.sun.faces.VIEW");
    int idx2 = html.indexOf("value=", idx);

    idx2 += "value='".length();
    int idx3 = html.indexOf("\"", idx2 + 1);

    String wk = html.substring(idx2, idx3);
    return wk;
  }


  
}
