/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.viewhandler;

import com.sun.faces.context.FacesContextImpl;
import javax.faces.component.UIOutput;
import junit.framework.*;
import javax.faces.component.UIViewRoot;
import javax.faces.context.ExternalContext;
import strawberry.mockup.MockExternalContextImpl2;
import strawberry.mockup.MockHttpServletResponse;
import strawberry.savemethod.SaveMethodForTest;
import strawberry.tools.FaceletViewHandlerSupportMock;
import strawberry.tools.ViewHandlerForTest;
/**
 * Created on 2007/04/20, 
 */
public class FaceletViewHandlerTest extends TestCase {
  
  public FaceletViewHandlerTest(String testName) {
    super(testName);
  }
  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }

  public static Test suite() {
    TestSuite suite = new TestSuite(FaceletViewHandlerTest.class);
    return suite;
  }

  /**
   *    request  com.sun.faces.VIEWȂ́A
   *    xhtmlǂfacelet鏈鎖m߂B
   */
  public void __testRestoreView() {
    System.out.println("restoreView");
    
//    ExternalContextExMock ec = new ExternalContextExMock();
   MockExternalContextImpl2 ec = new MockExternalContextImpl2();
   FacesContextImpl context = new FacesContextImpl(ec,null,null);
    //  FaceletViewHandler ̊O ViewHandler @bN
    ViewHandlerForTest outerVH = new ViewHandlerForTest();
    FaceletViewHandler instance = new FaceletViewHandler(outerVH);
    
    // xhtmlǂfacelet鏈̃bN
    FaceletViewHandlerSupportMock mock = new FaceletViewHandlerSupportMock();
    instance.setFaceletViewHandlerSupport(mock);
    
    final String viewId = "abc01";
    // eXgΏۃ\bhĂ
    UIViewRoot result = instance.restoreView(context, viewId);
    
    System.out.println("result = " + result);
    assertTrue( null != result );
    assertTrue( result instanceof UIViewRoot );
    // FaceletViewHandlerSupport#buildView Ă΂ꂽm߂
    assertTrue(mock.isBuildViewCalled());

    // OViewHandlercreateViewĂ΂Ĉ(viewId)
    // nĂ邱Ƃm߂
    String arg =  outerVH.getCreateViewArg();
    System.out.println("arg = " + arg);
    assertEquals(viewId, arg);
  }

  /**
   *    request  com.sun.faces.VIEWȂ́A
   *    xhtmlǂfacelet鏈鎖m߂B
   */
  public void __testRestoreView02() {
    System.out.println("restoreView02");
    
//    ExternalContextExMock ec = new ExternalContextExMock();
   MockExternalContextImpl2 ec = new MockExternalContextImpl2();
   FacesContextImpl context = new FacesContextImpl(ec,null,null);
    
//    ec.getRequestParameterMap().put("com.sun.faces.VIEW", "aaa");
    
    //  FaceletViewHandler ̊O ViewHandler @bN
    ViewHandlerForTest outerVH = new ViewHandlerForTest();
    FaceletViewHandler instance = new FaceletViewHandler(outerVH);
    UIViewRoot rootForTest = new UIViewRoot();
    instance.add(new SaveMethodForTest(rootForTest)); //Vsave\bhǉ
    
    // xhtmlǂfacelet鏈̃bN
    FaceletViewHandlerSupportMock mock = new FaceletViewHandlerSupportMock();
    instance.setFaceletViewHandlerSupport(mock);
    
    final String viewId = "abc01";
    // eXgΏۃ\bhĂ
    UIViewRoot result = instance.restoreView(context, viewId);
    
    System.out.println("result = " + result);
    assertTrue( rootForTest == result );
    assertTrue( result instanceof UIViewRoot );
    // FaceletViewHandlerSupport#buildView Ă΂ĂȂ
    assertTrue(! mock.isBuildViewCalled());

  }
  
  public void testRenderView() throws Exception {
    
    System.out.println("testRenderView");
    
//    ExternalContextExMock ec = new ExternalContextExMock();
    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    FacesContextImpl context = new FacesContextImpl(ec, null, null);
    
    UIViewRoot toRender = new UIViewRoot();
    UIOutput uio = new UIOutput();
    toRender.getChildren().add(uio);
    context.setViewRoot(toRender);
    
    context.getExternalContext().getRequestMap().put("facelets.stateManager", "test");
    
    
    //  FaceletViewHandler ̊O ViewHandler @bN
    ViewHandlerForTest outerVH = new ViewHandlerForTest();
    FaceletViewHandler instance = new FaceletViewHandler(outerVH);
    
    SaveMethodForTest saveMethod = new SaveMethodForTest();
    instance.add(saveMethod); //Vsave\bhǉ
    
    saveMethod.setRenderAndSaveResult("");
    
    
    // xhtmlǂfacelet鏈̃bN
    FaceletViewHandlerSupportMock mock = new FaceletViewHandlerSupportMock();
    instance.setFaceletViewHandlerSupport(mock);
    
    // eXgΏۃ\bhĂ
    instance.renderView(context, toRender);

    String str = getResponseAsString(ec);
    System.out.println("str = '" + str + "'");
    assertEquals("", str);
  }
  
  public String getResponseAsString(ExternalContext ec) {

    MockHttpServletResponse res = (MockHttpServletResponse) ec.getResponse();
    String wk = null;
    try {
      wk = res.getContentAsString();
    } catch (Exception ex) {
      throw new RuntimeException(ex);
    }
    return wk;
  }

}
