/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.viewhandler;

import com.sun.faces.context.FacesContextImpl;
import junit.framework.*;
import strawberry.mockup.MockExternalContextImpl2;
import strawberry.mockup.MockServletContext;
import strawberry.tools.ViewHandlerForTest;
/**
 * Created on 2007/06/14, 
 */
public class FaceletViewHandler_getActionURLTest extends TestCase {
  
  public FaceletViewHandler_getActionURLTest(String testName) {
    super(testName);
  }
  protected void setUp() throws Exception {  }
  protected void tearDown() throws Exception {  }

  public static Test suite() {
    TestSuite suite = new TestSuite(FaceletViewHandler_getActionURLTest.class);
    return suite;
  }

  
  public void testGetActionURL() throws Exception {
    
    System.out.println("testGetActionURL  ʏ ");
    
    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    FacesContextImpl context = new FacesContextImpl(ec, null, null);
    
    //  FaceletViewHandler ̊O ViewHandler @bN
    ViewHandlerForTest outerVH = new ViewHandlerForTest();
    FaceletViewHandler instance = new FaceletViewHandler(outerVH);
    
    // eXgΏۃ\bhĂ
    String actionUrl =     instance.getActionURL(context,"foo");

    System.out.println("actionUrl = '" + actionUrl + "'");
    assertEquals("foo", actionUrl);
  }
  
  public void testGetActionURLCustomize() throws Exception {
    
    System.out.println("testGetActionURL  JX^}CY ");
    
    MockExternalContextImpl2 ec = new MockExternalContextImpl2();
    FacesContextImpl context = new FacesContextImpl(ec, null, null);
    MockServletContext sc = (MockServletContext) ec.getContext();
    // ̐ݒ肪ƁAJX^}CYꂽviewIDvZ
    sc.addInitParameter("strawberry.CUSTOMIZED_VIEWID_MODE", "true");
    
    //  FaceletViewHandler ̊O ViewHandler @bN
    ViewHandlerForTest outerVH = new ViewHandlerForTest();
    FaceletViewHandler instance = new FaceletViewHandler(outerVH);
    
    // eXgΏۃ\bhĂ
    String actionUrl =     instance.getActionURL(context,"/foo");

    System.out.println("actionUrl = '" + actionUrl + "'");
    assertEquals("../foo", actionUrl);
  }

}
