/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.viewhandler;

import junit.framework.*;
import javax.faces.context.FacesContext;
import strawberry.context.FacesContextEL;
import strawberry.mockup.*;
import java.util.logging.*;
import javax.faces.application.ViewHandler;
import strawberry.ctx.ExternalContextImpl2;
import strawberry.mockup.MockServletContext;
/**
 * Created on 2007/06/07, 
 */
public class ViewHandlerImplTest extends TestCase {
    
    protected final static Logger log = Logger.getLogger("strawberry.ctx");
    
    public ViewHandlerImplTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {    }
    protected void tearDown() throws Exception {    }

    public static Test suite() {
        TestSuite suite = new TestSuite(ViewHandlerImplTest.class);
        return suite;
    }

    /**
     * Test of renderView method, of class strawberry.viewhandler.ViewHandlerImpl.
     */
    public void testConvertViewId() throws Exception {
        System.out.println("testConvertViewId-----------");
        log.setLevel(Level.FINEST);
        
//        ExternalContextExMock ec = new ExternalContextExMock();
        MockExternalContextImpl2 ec = new MockExternalContextImpl2();
        FacesContext faces = new FacesContextEL(ec);
        ViewHandlerImpl instance = new ViewHandlerImpl();
        
        String str =instance.convertViewId(faces, "/faces/FEL01");
        
        System.out.println("ans = " + str);
        assertEquals("/faces/FEL01.jsp", str);
    }

    /**
     * Test of renderView method, of class strawberry.viewhandler.ViewHandlerImpl.
     */
    public void testConvertViewId_xmlSetting() throws Exception {
        System.out.println("testConvertViewId-----------");
        log.setLevel(Level.FINEST);
        
//        ExternalContextExMock ec = new ExternalContextExMock();
        // strawberry.mockup.MockServletContext - getInitParameter(javax.faces.DEFAULT_SUFFIX)


        ExternalContextImpl2 ec = new ExternalContextImpl2(new MockServletContext(),
                                                             new MockHttpServletRequest(),
                                                             new MockHttpServletResponse());
      
        MockServletContext sc = (MockServletContext) ec.getContext();
        sc.setAttribute("javax.faces.DEFAULT_SUFFIX", ".html");   // ǂ߂Ȃ
        sc.addInitParameter("javax.faces.DEFAULT_SUFFIX", ".html"); // ǂ߂iȂHj
        

        System.out.println("  getInitParameter(ViewHandler.DEFAULT_SUFFIX_PARAM_NAME) = " +
        ViewHandler.DEFAULT_SUFFIX_PARAM_NAME);
        
        FacesContext faces = new FacesContextEL(ec);
        ViewHandlerImpl instance = new ViewHandlerImpl();
        
        String str =instance.convertViewId(faces, "/faces/FEL01");
        
        System.out.println("ans = " + str);
        assertEquals("/faces/FEL01.html", str);
    }


}
