/*
 * Copyright (C)  2007 Masahito Henmi, All rights reserved.
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 */
package strawberry.wrapper;

import strawberry.ctx.ExternalContextImpl2;
import java.util.Map;
import junit.framework.*;
import strawberry.mockup.MockHttpServletRequest;
import strawberry.mockup.MockHttpServletResponse;
import strawberry.mockup.MockServletContext;
/**
 * Created on 2007/06/10, 
 */
public class Tomcat3HttpServletRequestTest extends TestCase {
    
    public Tomcat3HttpServletRequestTest(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {    }
    protected void tearDown() throws Exception {    }

    public static Test suite() {
        TestSuite suite = new TestSuite(Tomcat3HttpServletRequestTest.class);
        return suite;
    }

    /**
     * Test of getParameter method, of class strawberry.wrapper.Tomcat3HttpServletRequest.
     */
    public void testGetParameter() throws Exception {
        System.out.println("getParameter");
        
        MockHttpServletRequest tomcat = new MockHttpServletRequest();

        String kanji = "";
        String iso = new String(kanji.getBytes("Shift_JIS"), "8859_1");
        System.out.println("bytes =" + iso.length());
        tomcat.addParameter("aaa", iso);

        String kana = "";
        String iso2 = new String(kana.getBytes("Shift_JIS"), "8859_1");
        System.out.println("bytes =" + iso2.length());
        tomcat.addParameter("bbb", iso2);
        
        byte[] arr = {'a', 13, 10, 0x7f, 'b'};
        String bin = new String(arr, "8859_1");
        tomcat.addParameter("ccc", bin);
        
        Tomcat3HttpServletRequest instance = new Tomcat3HttpServletRequest(tomcat);
        ExternalContextImpl2 ec = new ExternalContextImpl2(new MockServletContext(),
                                                              instance,
                                                             new MockHttpServletResponse());
        
        Map reqParam = ec.getRequestParameterMap();

        System.out.println("aaa =" + reqParam.get("aaa"));
        System.out.println("bbb =" + reqParam.get("bbb"));
        System.out.println("ccc =" + reqParam.get("ccc"));

        assertEquals(kanji, reqParam.get("aaa"));
        assertEquals(kana, reqParam.get("bbb"));
        assertEquals("ab", reqParam.get("ccc"));
    }
    
}
