/*
 * The contents of this file are subject to the terms
 * of the Common Development and Distribution License
 * (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at
 * https://javaserverfaces.dev.java.net/CDDL.html or
 * legal/CDDLv1.0.txt. 
 * See the License for the specific language governing
 * permission and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL
 * Header Notice in each file and include the License file
 * at legal/CDDLv1.0.txt.    
 * If applicable, add the following below the CDDL Header,
 * with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * [Name of File] [ver.__] [Date]
 * 
 * Copyright 2006 Sun Microsystems Inc. All Rights Reserved
 */


package com.sun.faces.el.impl;

import java.lang.reflect.Method;

/**
 * <p>The interface to a map between EL function names and methods.</p>
 * <p/>
 * <p>Classes implementing this interface may, for instance, consult
 * tag library information to resolve the map.</p>
 */

public interface FunctionMapper {

    /**
     * <p>Resolves the specified local name and prefix into a Java.lang.Method.
     * Returns null if the prefix and local name are not found.</p>
     *
     * @param prefix    the prefix of the function, or "" if no prefix
     * @param localName the short name of the function
     * @return the result of the method mapping.  Null means no entry found.
     */
    public Method resolve(String prefix, String localName);
}
